/* Copyright (c) 1989 The Regents of the University of California. All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met: 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer. 2.
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution. 3. All advertising
 * materials mentioning features or use of this software must display the
 * following acknowledgement: This product includes software developed by the
 * University of California, Berkeley and its contributors. 4. Neither the
 * name of the University nor the names of its contributors may be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#)pathnames.h 5.2 (Berkeley) 6/1/90 */

#ifndef __EMX__
 
#define _PATH_FTPUSERS  "/etc/ftpusers"
#define _PATH_FTPACCESS "/usr/local/etc/ftpaccess"
#define _PATH_EXECPATH  "/bin/ftp-exec"
#define _PATH_PIDNAMES  "/usr/local/daemon/ftpd/ftp.pids-%s"
#define _PATH_CVT       "/usr/local/etc/ftpconversions"
#define _PATH_XFERLOG   "/usr/adm/xferlog"
#define _PATH_PRIVATE   "/etc/ftpgroups"

#ifndef _PATH_UTMP
#define _PATH_UTMP      "/etc/utmp"
#define _PATH_WTMP      "/usr/adm/wtmp"
#define _PATH_LASTLOG   "/usr/adm/lastlog"
#endif

#define _PATH_BSHELL    "/bin/sh"
#define _PATH_DEVNULL   "/dev/null"

#ifdef  HOST_ACCESS
#define _PATH_FTPHOSTS  "/usr/local/etc/ftphosts"
#endif

#else /* __EMX__ */

extern char _PATH_FTPUSERS[256];  /* "/etc/ftpusers" */
extern char _PATH_FTPACCESS[256]; /* "/usr/local/etc/ftpaccess" */
extern char _PATH_EXECPATH[256];  /* "/bin/ftp-exec" */
extern char _PATH_PIDNAMES[256];  /* "/usr/local/daemon/ftpd/ftp.pids-%s" */
extern char _PATH_CVT[256];       /* "/usr/local/etc/ftpconversions" */
extern char _PATH_XFERLOG[256];   /* "/usr/adm/xferlog" */
extern char _PATH_PRIVATE[256];   /* "/etc/ftpgroups" */
extern char _PATH_SHELLS[256];    /* "/etc/shells" */

#ifndef _PATH_UTMP
extern char _PATH_UTMP[256];      /* "/etc/utmp" */
extern char _PATH_WTMP[256];      /* "/usr/adm/wtmp" */
extern char _PATH_LASTLOG[256];   /* "/usr/adm/lastlog" */
#endif

extern char _PATH_BSHELL[256];    /* "/bin/sh" */
extern char _PATH_DEVNULL[256];   /* "/dev/null" */

#ifdef  HOST_ACCESS
extern char _PATH_FTPHOSTS[256];  /* "/usr/local/etc/ftphosts" */
#endif

#endif /* __EMX__ */